'
'   ______
'  /      \             WIN-G The 'Windowed' Graphical User Interface
' |        |            Beta 1
' |   __   |            Looks bloody cool, A bit slow on old systems
' |  /  |__|
' |  |            __
' |  |  ___      (__)
' |  | |_  |_   ____
' |  \--|  | | | |  |
' |        | \_/ |  |
' |        |     |  |
'  \______/\____^_\_|
'
'
'Windowing System
'$INCLUDE: 'Headers\WinG\Win-GUI.Bi'

'ON ERROR GOTO Debug:

SYSTEM

Debug:
ExitGUI
SYSTEM

SUB ChangeObject (A, X, Y, X1, Y1, Win, Text$, ID, Flags, Spec, ToolTip$, Mask)

XX = Objects(A).X
YY = Objects(A).Y
WW = Objects(A).W
HH = Objects(A).H

IF Selected THEN
 S = Objects(A).WinIndex
 ReFreshObject A
 SetViewPort Sx, Sy, Sx1, Sy1
 DrawWindow S
 ReDrawArea Sx, Sy, Sx1, Sy1, S
 SetViewPort 0, 0, ResX, ResY
END IF
  
  FOR B = 0 TO 15
   IF Mask AND 2 ^ B THEN
    SELECT CASE B

     CASE 0
      Objects(A).X = X
      
     CASE 1
      Objects(A).Y = Y

     CASE 2
      Objects(A).W = X1
      
     CASE 3
      Objects(A).H = Y1
      
     CASE 4
      Objects(A).WinIndex = Win

     CASE 5
      IF Objects(A).TextPtr <> 0 THEN
       TextBuf$(Objects(A).TextPtr) = ""
      END IF
      Objects(A).TextPtr = InTextBuffer(Text$, -1)

     CASE 6
      Objects(A).ID = ID

     CASE 7
      Objects(A).Flags = Flags

     CASE 8
      Objects(A).Style = Spec

     CASE 9
      IF Objects(A).ToolPtr <> 0 THEN
       TextBuf$(Objects(A).ToolPtr) = ""
      END IF
      Objects(A).ToolPtr = InTextBuffer(ToolTip$, -1)
     
     CASE ELSE
     END SELECT
    END IF
   NEXT
ObjectDraw A
ReFreshObject A

END SUB

SUB ChangeWindow (A, X, Y, SizeX, SizeY, Border, RealX, RealY, ViewX, ViewY, Text$, Mask)
  FOR B = 0 TO 15
   IF Mask AND 2 ^ B THEN
    SELECT CASE B

     CASE 0
      Windows(A).X = X
      Windows(A).ResizeX1 = Windows(A).X

     CASE 1
      Windows(A).Y = Y
      Windows(A).ResizeY1 = Windows(A).Y

     CASE 2
      Windows(A).W = SizeX
      Windows(A).ResizeX2 = Windows(A).W

     CASE 3
      Windows(A).H = SizeY
      Windows(A).ResizeY2 = Windows(A).H

     CASE 4
      Windows(A).Properties = Border
      Windows(A).Properties = Windows(A).Properties OR 1

     CASE 5
      Windows(A).RealX = RealX

     CASE 6
      Windows(A).RealY = RealY

     CASE 7
      Windows(A).ViewX = ViewX

     CASE 8
      Windows(A).ViewY = ViewY
  
     CASE 9
      IF Windows(A).TextPtr <> 0 THEN
       TextBuf$(Windows(A).TextPtr) = ""
      END IF
      Windows(A).TextPtr = InTextBuffer(Text$, -1)

     CASE ELSE
     END SELECT
    END IF
   NEXT
END SUB

SUB CheckScroll (A)
'Window Check for Scroll Bar Resize/Redraw (Put in DrawWindow ?)
 IF (Windows(A).Properties AND Exist) = Exist THEN
  IF Windows(A).RealX > Windows(A).W AND (Windows(A).Properties AND ScrollX) = 0 THEN
   Windows(A).DataOffH = Windows(A).DataOffH + 10
   Windows(A).Properties = Windows(A).Properties XOR ScrollX
  END IF

  IF Windows(A).RealX < Windows(A).W AND (Windows(A).Properties AND ScrollX) <> 0 THEN
   Windows(A).DataOffH = Windows(A).DataOffH - 10
   Windows(A).Properties = Windows(A).Properties XOR ScrollX
  END IF


  IF Windows(A).RealY > Windows(A).H AND (Windows(A).Properties AND ScrollY) = 0 THEN
   Windows(A).DataOffW = Windows(A).DataOffW + 10
   Windows(A).Properties = Windows(A).Properties XOR ScrollY
  END IF

  IF Windows(A).RealY < Windows(A).H AND (Windows(A).Properties AND ScrollY) <> 0 THEN
   Windows(A).DataOffW = Windows(A).DataOffW - 10
   Windows(A).Properties = Windows(A).Properties XOR ScrollY
  END IF

  IF (Windows(A).Properties AND ScrollX) <> 0 THEN
    ViewX = (Windows(A).X + Windows(A).W - Windows(A).DataOffW) - (Windows(A).X + Windows(A).DataOffX)
   IF Windows(A).ViewX > Windows(A).RealX - ViewX THEN Windows(A).ViewX = Windows(A).RealX - ViewX
  ELSE
   Windows(A).ViewX = 0
  END IF

  IF (Windows(A).Properties AND ScrollY) <> 0 THEN
   ViewY = (Windows(A).H + Windows(A).Y - Windows(A).DataOffH) - (Windows(A).Y + Windows(A).DataOffY)
   IF Windows(A).ViewY > Windows(A).RealY - ViewY THEN Windows(A).ViewY = Windows(A).RealY - ViewY
  ELSE
   Windows(A).ViewY = 0
  END IF
 END IF
END SUB

SUB CloseWindow (Win)
' Closes a Windows, deallocates components, And Switches Window Order

IF Windows(Win).Properties AND Exist = Exist THEN
 
 IF Win = WinPtr THEN WinPtr = Windows(WinPtr).Nxt
 Windows(Windows(Win).Nxt).Prv = Windows(Win).Prv
 Windows(Windows(Win).Prv).Nxt = Windows(Win).Nxt
 Windows(Win).Properties = 0
 ReDrawArea Windows(Win).X, Windows(Win).Y, Windows(Win).W, Windows(Win).H, -1

 DestroyWinObjects Win
 DeallExpMem Windows(Win).Handle
END IF

DrawWindow ActiveWin
DrawWinScroll ActiveWin
DrawObjects ActiveWin
ReDrawArea 0, 0, ResX, ResY, ActiveWin

END SUB

FUNCTION Collide (X, Y, W, H, X2, Y2, W2, H2)
   IF X + W >= X2 AND X <= X2 + W2 THEN
    IF Y + H >= Y2 AND Y <= Y2 + H2 THEN
     Collide = True
     EXIT FUNCTION
    END IF
   END IF
END FUNCTION

FUNCTION CreateNewWindow (X, Y, SizeX, SizeY, Border, RealX, RealY, ViewX, ViewY, Text$)

FOR A = 0 TO MaxWindows
 IF (Windows(A).Properties AND Exist) = 0 THEN
  FOR B = 0 TO MaxObjects
   IF (Objects(B).Properties AND Exist) <> Exist THEN
    Windows(A).Obj1st = B
    Objects(B).Properties = Objects(B).Properties OR 1
    Objects(B).Prv = B
    Objects(B).Nxt = B
    EXIT FOR
   END IF
  NEXT

  Windows(A).Nxt = Windows(WinPtr).Nxt
  Windows(WinPtr).Nxt = A
  Windows(A).Prv = WinPtr
  Windows(Windows(A).Nxt).Prv = A

  Windows(A).DataOffY = 5
  Windows(A).DataOffX = 5
  Windows(A).DataOffW = 5
  Windows(A).DataOffH = 5

  IF (Border AND Resizeable) = Resizeable THEN
   Windows(A).DataOffY = Windows(A).DataOffY + 2
   Windows(A).DataOffX = Windows(A).DataOffX + 2
   Windows(A).DataOffW = Windows(A).DataOffW + 2
   Windows(A).DataOffH = Windows(A).DataOffH + 2
  END IF

  IF (Border AND TitleBar) = TitleBar THEN Windows(A).DataOffY = Windows(A).DataOffY + 20

  Windows(A).Handle = AllExpMem(1)
  ChangeWindow A, X, Y, SizeX, SizeY, Border, RealX, RealY, ViewX, ViewY, Text$, 1023
  ReSizeWinBuf A
  ReDrawArea X, Y, SizeX, SizeY, -1
  MakeWindowActive A
  CreateNewWindow = A
  EXIT FUNCTION
 END IF
NEXT
CreateNewWindow = -1 'Failed
END FUNCTION

FUNCTION CreateObject (X, Y, X1, Y1, Win, Text$, ID, Flags, Spec, ToolTip$)

FOR A = 0 TO MaxObjects
 IF (Objects(A).Properties AND Exist) = False THEN

  IF Spec = 5 THEN
   FOR S = 0 TO MaxObjects
    IF (Objects(S).Style = 5) AND (Objects(S).Properties AND Exist) = Exist AND (Objects(S).ID = Objects(A).ID) THEN Objects(S).Flags = 0
   NEXT
  END IF

  Objects(A).Nxt = Objects(Windows(Win).Obj1st).Nxt
  Objects(Windows(Win).Obj1st).Nxt = A
  Objects(A).Prv = Windows(Win).Obj1st
  Objects(Objects(A).Nxt).Prv = A

  Objects(A).Properties = Objects(A).Properties OR 1
  Objects(A).Style = Spec
  Objects(A).X = X
  Objects(A).Y = Y
  Objects(A).WinIndex = Win
  Objects(A).W = X1
  Objects(A).H = Y1
  Objects(A).Flags = Flags
  Objects(A).ID = ID
  
  'Special Text Handler
  'Search Buffer
  Objects(A).TextPtr = InTextBuffer(Text$, -1)
  Objects(A).ToolPtr = InTextBuffer(ToolTip$, -1)

  IF Spec = 9 OR Spec = 18 THEN
   D = 0
   FOR S = 1 TO LEN(TextBuf$(Objects(A).TextPtr))
    Data1$ = GetLineWrap$(TextBuf$(Objects(A).TextPtr), S, X1 - 4)
    S = S + LEN(Data1$)
    D = D + 1
   NEXT
   Objects(A).ToolPtr = D
  END IF

  CreateObject = A
  ObjectDraw A
  ReFreshObject A
  EXIT FUNCTION
 END IF
NEXT
CreateObject = -1
END FUNCTION

SUB DefLayer (X, Y, W, H, L)
   '/* Make sure all other layers do not overlap */
   ML = LayerNum
   X1 = X
   Y1 = Y
   X2 = X + W
   Y2 = Y + H
   FOR N = 0 TO ML
      IF Regions(N).Exist THEN
	    X3 = Regions(N).X
	    Y3 = Regions(N).Y
	    X4 = Regions(N).X1
	    Y4 = Regions(N).Y1
	    OX = Regions(N).OffX
	    OY = Regions(N).OffY
	    L2 = Regions(N).WinName

	    '/* Does object overlap? */
	    IF X3 >= X1 AND X4 <= X2 AND Y3 >= Y1 AND Y4 <= Y2 THEN
	       Regions(N).Exist = False
	    END IF

	    '/* Check if left or right layers need resizing */
	    IF (Y3 >= Y1 AND Y3 <= Y2) OR (Y4 >= Y1 AND Y4 <= Y2) OR (Y3 < Y1 AND Y4 > Y2) THEN
	       '/* Left hand side */
	       IF X3 < X1 AND X4 >= X1 THEN
		  Regions(N).Exist = False
		  LayerNum = LayerNum + 1
		  Regions(LayerNum).X = X3
		  Regions(LayerNum).X1 = X1 - 1
		  Regions(LayerNum).Y = Y3
		  Regions(LayerNum).Y1 = Y4
		  Regions(LayerNum).OffX = OX
		  Regions(LayerNum).OffY = OY
		  Regions(LayerNum).Exist = True
		  Regions(LayerNum).WinName = L2
	       END IF

	       '/* Right hand side */
	       IF X3 <= X2 AND X4 > X2 THEN
		  Regions(N).Exist = False
		  LayerNum = LayerNum + 1
		  Regions(LayerNum).X = X2 + 1
		  Regions(LayerNum).X1 = X4
		  Regions(LayerNum).Y = Y3
		  Regions(LayerNum).Y1 = Y4
		  Regions(LayerNum).OffX = OX
		  Regions(LayerNum).OffY = OY
		  Regions(LayerNum).Exist = True
		  Regions(LayerNum).WinName = L2
	       END IF
	    END IF

	    '/* Check if left or right layers need resizing */
	    IF (X3 >= X1 AND X3 <= X2) OR (X4 >= X1 AND X4 <= X2) OR (X3 < X1 AND X4 > X2) THEN
	       '/* Top */
	       IF Y3 < Y1 AND Y4 >= Y1 THEN
		  Regions(N).Exist = False
		  LayerNum = LayerNum + 1
		  IF X3 > X1 THEN
		     Regions(LayerNum).X = X3
		  ELSE
		     Regions(LayerNum).X = X1
		  END IF
		  IF X4 < X2 THEN
		     Regions(LayerNum).X1 = X4
		  ELSE
		     Regions(LayerNum).X1 = X2
		  END IF
		  Regions(LayerNum).Y = Y3
		  Regions(LayerNum).Y1 = Y1 - 1
		  Regions(LayerNum).OffX = OX
		  Regions(LayerNum).OffY = OY
		  Regions(LayerNum).Exist = True
		  Regions(LayerNum).WinName = L2
	       END IF

	       '/* Bottom */
	       IF Y3 <= Y2 AND Y4 > Y2 THEN
		  Regions(N).Exist = False
		  LayerNum = LayerNum + 1
		  IF X3 > X1 THEN
		     Regions(LayerNum).X = X3
		  ELSE
		     Regions(LayerNum).X = X1
		  END IF
		  IF X4 < X2 THEN
		     Regions(LayerNum).X1 = X4
		  ELSE
		     Regions(LayerNum).X1 = X2
		  END IF
		  Regions(LayerNum).Y = Y2 + 1
		  Regions(LayerNum).Y1 = Y4
		  Regions(LayerNum).OffX = OX
		  Regions(LayerNum).OffY = OY
		  Regions(LayerNum).Exist = True
		  Regions(LayerNum).WinName = L2
	       END IF
	    END IF
	' EXIT FOR
      END IF
   NEXT N

   LayerNum = LayerNum + 1
   Regions(LayerNum).X = X1
   Regions(LayerNum).Y = Y1
   Regions(LayerNum).X1 = X2
   Regions(LayerNum).Y1 = Y2
   Regions(LayerNum).OffX = X1
   Regions(LayerNum).OffY = Y1
   Regions(LayerNum).Exist = True
   Regions(LayerNum).WinName = L
END SUB

SUB DestroyWinObjects (Win)

'Destroy Objects (And Text in that Window)

FOR A = 0 TO MaxObjects
 IF Objects(A).WinIndex = Win THEN
  TextBuf$(Objects(A).TextPtr) = ""
  TextBuf$(Objects(A).ToolPtr) = ""
  RemoveObject A
 END IF
NEXT

END SUB

SUB DoUpdate
' -=-=-=-=-=-=-=-=-=-=-=[ UPDATE MOUSE ETC ]=-=-=-=-=-=-=-=-=-=-=-=-=-=-

Future.UpdateMouse

'Used for redraw check sometime?
OldMouseX = MouseX
OldMouseY = MouseY
OldClick = Click

'Buffer the Mouse
MouseX = Future.MouseX
MouseY = Future.MouseY

IF (Future.MouseB AND 3) = 0 THEN Click = 0
IF (Future.MouseB AND 2) > 0 THEN Click = Click - 1: HolderX = MouseX
IF (Future.MouseB AND 1) > 0 THEN Click = Click + 1: HolderY = MouseY
IF ABS(Click) > 50 THEN Click = OldClick

'If Dual Click
IF (Future.MouseB AND 3) = 3 THEN Click = 100
'If Middle Button/Side Button
IF (Future.MouseB AND 4) = 4 THEN Click = 1000

OldKey$ = KBD$
KBD$ = INKEY$
IsKey = 0

'IF KBD$ = "d" THEN DmpLayerz
' -=-=-=-=-=- [ MOUSE CHECK DONE. DO WINDOW CHECKING ] -=-=-=-=-=-=-=-=-=-

OldActiveWin = ActiveWin

IF MouseDo THEN
 OX1 = Windows(ActiveWin).X
 OY1 = Windows(ActiveWin).Y
 OX2 = Windows(ActiveWin).W
 OY2 = Windows(ActiveWin).H

'If a Mouse n Window event Set then do it here
SELECT CASE MouseDo
CASE 1
 'Move Tile bar
 IF Click = 0 THEN
  MouseDo = 0
  ReDrawArea OX1, OY1, OX2, OY2, -1
 ELSE
  Windows(ActiveWin).X = MouseX - MPosX
  Windows(ActiveWin).Y = MouseY - MPosY
  IF MouseX <> OldMouseX OR MouseY <> OldMouseY THEN
   ReDrawArea OX1, OY1, OX2, OY2, -1
   EXIT SUB
  END IF
 END IF
CASE 2
 'Resize Window
 IF Click = 0 THEN
  Future.MouseOn
  MouseDo = 0
  Borderz = 0
  ReSizeWinBuf ActiveWin
  Windows(Win).Properties = Windows(Win).Properties OR Dirty
  ReDrawArea 0, 0, ResX, ResY, -1
 ELSE
  IF MouseX <> OldMouseX OR MouseY <> OldMouseY THEN
   Future.MouseOff
   SetMaskColor -1
   FOR A = 0 TO 3
    Temp = Borderz AND 2 ^ A
    IF Temp <> 0 THEN

    SELECT CASE A
    CASE 0
     Windows(ActiveWin).H = MouseY + 1 - Windows(ActiveWin).Y
     IF Windows(ActiveWin).H < Windows(ActiveWin).DataOffY THEN Windows(ActiveWin).H = Windows(ActiveWin).DataOffY

    CASE 1
     Temp1 = Windows(ActiveWin).Y
     Ypos = Windows(ActiveWin).Y + Windows(ActiveWin).H
     Windows(ActiveWin).Y = MouseY
     Windows(ActiveWin).H = Ypos - Windows(ActiveWin).Y
     IF Windows(ActiveWin).H < Windows(ActiveWin).DataOffY THEN Windows(ActiveWin).H = Windows(ActiveWin).DataOffY: Windows(ActiveWin).Y = Temp1

    CASE 2
     Temp1 = Windows(ActiveWin).X
     Xpos = Windows(ActiveWin).X + Windows(ActiveWin).W
     Windows(ActiveWin).X = MouseX
     Windows(ActiveWin).W = Xpos - Windows(ActiveWin).X
     IF Windows(ActiveWin).W < 160 THEN Windows(ActiveWin).W = 160: Windows(ActiveWin).X = Temp1
     
    CASE 3
     Windows(ActiveWin).W = MouseX + 1 - Windows(ActiveWin).X
     IF Windows(ActiveWin).W < 160 THEN Windows(ActiveWin).W = 160

    CASE ELSE
    END SELECT

    END IF
   NEXT
  
   IF OX2 + OX1 > Windows(ActiveWin).X + Windows(ActiveWin).W THEN ReDrawArea Windows(ActiveWin).X + Windows(ActiveWin).W, Windows(ActiveWin).Y, (OX1 + OX2) - (Windows(ActiveWin).X + Windows(ActiveWin).W), OY2, -1
   IF OY2 + OY1 > Windows(ActiveWin).Y + Windows(ActiveWin).H THEN ReDrawArea Windows(ActiveWin).X, Windows(ActiveWin).Y + Windows(ActiveWin).H, OX2, (OY1 + OY2) - (Windows(ActiveWin).Y + Windows(ActiveWin).H), -1
   IF OX1 < Windows(ActiveWin).X THEN ReDrawArea OX1, Windows(ActiveWin).Y, Windows(ActiveWin).X - OX1, OY2, -1
   IF OY1 < Windows(ActiveWin).Y THEN ReDrawArea OX1, OY1, OX2, Windows(ActiveWin).Y - OY1, -1
   DrawBox3D Windows(ActiveWin).X, Windows(ActiveWin).Y, Windows(ActiveWin).X + Windows(ActiveWin).W, Windows(ActiveWin).Y + Windows(ActiveWin).H, Colors(7), Colors(11), 20

   EXIT SUB
  END IF
 END IF

 CASE 3, 4'X axis Scroll
  IF Click = 0 THEN
    Windows(Win).Properties = Windows(Win).Properties OR Dirty
    MouseDo = 0
   ELSE
    IF MouseX <> OldMouseX OR MouseY <> OldMouseY THEN
    IF MouseDo = 3 THEN
     ScrollViewX = MouseX - (Windows(ActiveWin).X + Windows(ActiveWin).DataOffX) - 13
     BarLenX = Windows(ActiveWin).W - 31
     Windows(ActiveWin).ViewX = (ScrollViewX / BarLenX) * Windows(ActiveWin).RealX
    ELSE
     ScrollViewY = MouseY - (Windows(ActiveWin).Y + Windows(ActiveWin).DataOffY) - 13
     BarLenY = Windows(ActiveWin).H - 31
     Windows(ActiveWin).ViewY = (ScrollViewY / BarLenY) * Windows(ActiveWin).RealY
    END IF
    
    IF Windows(ActiveWin).ViewY < 0 THEN Windows(ActiveWin).ViewY = 0
    IF Windows(ActiveWin).ViewX < 0 THEN Windows(ActiveWin).ViewX = 0
    
    Selected = 0
    DrawWindow ActiveWin
    DrawWinScroll ActiveWin
    DrawObjects ActiveWin
    
    IF OX1 < 0 THEN OX2 = OX2 - OX1: OX1 = 0
    IF OY1 < 0 THEN OY1 = OY1 - OY1: OY1 = 0
    
    ReDrawArea OX1, OY1, OX2, OY2, ActiveWin
   END IF
   EXIT SUB
  END IF

 CASE ELSE
 MouseDo = 0
END SELECT
END IF

IF Click = 1 AND (Windows(ActiveWin).Properties AND MaxiMised) = 0 THEN
  D = Win1st
  A = WinPtr
  DO
   IF MouseY > Windows(A).Y AND MouseY < Windows(A).Y + Windows(A).H THEN
    IF MouseX > Windows(A).X AND MouseX < Windows(A).X + Windows(A).W THEN
     IF A <> Win1st THEN
      D = A
      EXIT DO
     END IF
    END IF
   END IF
   A = Windows(A).Nxt
  LOOP WHILE A <> WinPtr
 IF D <> ActiveWin THEN
  MakeWindowActive D
  ActiveWin = D
 END IF
END IF

'Mouse Clicked and No Windows Events (MouseDo Var) are active
IF Click <> 0 AND MouseDo = 0 THEN

 'If Title Bar Exist
 IF (Windows(ActiveWin).Properties AND TitleBar) = TitleBar THEN
  IF (MouseY > Windows(ActiveWin).Y + 5 AND MouseY < Windows(ActiveWin).Y + 20) THEN

   'If Close Button Exist and Clicked then
   IF (Windows(ActiveWin).Properties AND CloseWin) = CloseWin THEN
    IF MouseX > Windows(ActiveWin).W + Windows(ActiveWin).X - 18 AND MouseX < Windows(ActiveWin).W + Windows(ActiveWin).X - 7 THEN
     IF MouseY > Windows(ActiveWin).Y + 7 AND MouseY < Windows(ActiveWin).Y + 18 THEN
      ReDrawArea ToolX, ToolY, ToolW, ToolH, -1
      CloseWindow ActiveWin
      END IF
     END IF
    END IF

 'If Maximise Button Exist and Clicked
 IF (Windows(ActiveWin).Properties AND Maximise) = Maximise THEN
  'Maximise
  IF MouseX > Windows(ActiveWin).W + Windows(ActiveWin).X - 34 AND MouseX < Windows(ActiveWin).W + Windows(ActiveWin).X - 23 THEN
   IF MouseY > Windows(ActiveWin).Y + 7 AND MouseY < Windows(ActiveWin).Y + 18 THEN
    IF (Windows(ActiveWin).Properties AND MiniMised) = 0 THEN
     MouseDo = 0
     SWAP Windows(ActiveWin).ResizeX1, Windows(ActiveWin).X
     SWAP Windows(ActiveWin).ResizeY1, Windows(ActiveWin).Y
     SWAP Windows(ActiveWin).ResizeX2, Windows(ActiveWin).W
     SWAP Windows(ActiveWin).ResizeY2, Windows(ActiveWin).H
     IF (Windows(ActiveWin).Properties AND MaxiMised) = 0 THEN
      Windows(ActiveWin).X = 1
      Windows(ActiveWin).Y = 1
      Windows(ActiveWin).W = ResX
      Windows(ActiveWin).H = ResY
     END IF
     Windows(ActiveWin).Properties = Windows(ActiveWin).Properties XOR MaxiMised
     ReSizeWinBuf ActiveWin
     ReDrawArea 0, 0, ResX, ResY, -1
    END IF
   END IF
  END IF
 END IF

 'If Misimise Button Clicked
 IF (Windows(ActiveWin).Properties AND Minimise) = Minimise THEN
  IF MouseX > Windows(ActiveWin).W + Windows(ActiveWin).X - 48 AND MouseX < Windows(ActiveWin).W + Windows(ActiveWin).X - 37 THEN
   IF MouseY > Windows(ActiveWin).Y + 7 AND MouseY < Windows(ActiveWin).Y + 18 THEN
    IF (Windows(ActiveWin).Properties AND MaxiMised) = 0 THEN
     MouseDo = 0
     SWAP Windows(ActiveWin).RealX, Windows(ActiveWin).ResizeX1
     SWAP Windows(ActiveWin).RealY, Windows(ActiveWin).ResizeY1
     SWAP Windows(ActiveWin).H, Windows(ActiveWin).ResizeY2
     IF (Windows(ActiveWin).Properties AND MiniMised) = 0 THEN
      Windows(ActiveWin).RealX = 1
      Windows(ActiveWin).RealY = 1
      Windows(ActiveWin).H = Windows(ActiveWin).DataOffY
     END IF
     Windows(ActiveWin).Properties = Windows(ActiveWin).Properties XOR MiniMised
     ReSizeWinBuf ActiveWin
     ReDrawArea Windows(ActiveWin).X, Windows(ActiveWin).Y, Windows(ActiveWin).W, Windows(ActiveWin).ResizeY2, -1
    END IF
   END IF
  END IF
 END IF

 'Else If Title Bar Clicked then
  IF (Windows(ActiveWin).Properties AND MaxiMised) = 0 THEN
   'Windowed event 1 set
    MouseDo = 1
    'Get Mouse Cors to take
    MPosX = MouseX - Windows(ActiveWin).X
    MPosY = MouseY - Windows(ActiveWin).Y
    EXIT SUB
   END IF
  END IF
 END IF

' If the Windows is Resize able and border was clicked then
 IF (Windows(ActiveWin).Properties AND Resizeable) = Resizeable THEN
  IF MouseY > Windows(ActiveWin).Y AND MouseY < Windows(ActiveWin).Y + Windows(ActiveWin).H THEN
   IF MouseX > Windows(ActiveWin).X AND MouseX < Windows(ActiveWin).X + Windows(ActiveWin).W THEN
    IF (Windows(ActiveWin).Properties AND MaxiMised) = 0 THEN
     'Set Windows event 2, Resize + Where to resize
     IF MouseX < Windows(ActiveWin).X + 5 THEN Borderz = Borderz OR 2 ^ 2
     IF MouseY < Windows(ActiveWin).Y + 5 THEN Borderz = Borderz OR 2 ^ 1
     IF MouseX > Windows(ActiveWin).X + Windows(ActiveWin).W - 5 THEN Borderz = Borderz OR 2 ^ 3
     IF MouseY > Windows(ActiveWin).Y + Windows(ActiveWin).H - 5 THEN Borderz = Borderz OR 2 ^ 0
     MPosX = MouseX - Windows(ActiveWin).X
     MPosY = MouseY - Windows(ActiveWin).Y
     IF Borderz <> 0 THEN MouseDo = 2
    END IF
   END IF
  END IF
 END IF

 'If Not Minimised and Scroll X axis exist, check X axis Scroll bar
  IF (Windows(ActiveWin).Properties AND ScrollX + MiniMised) = ScrollX THEN
    BarLenX = (Windows(ActiveWin).X + Windows(ActiveWin).W - Windows(ActiveWin).DataOffW - 12) - (Windows(ActiveWin).X + Windows(ActiveWin).DataOffX + 13) - 4
    ViewX = (Windows(ActiveWin).X + Windows(ActiveWin).W - Windows(ActiveWin).DataOffW) - (Windows(ActiveWin).X + Windows(ActiveWin).DataOffX)
    ScrollLenX = (ViewX / Windows(ActiveWin).RealX) * BarLenX
    ScrollViewX = (Windows(ActiveWin).ViewX / Windows(ActiveWin).RealX) * BarLenX

   IF MouseY > Windows(ActiveWin).H + Windows(ActiveWin).Y - Windows(ActiveWin).DataOffH + 2 AND MouseY < Windows(ActiveWin).H + Windows(ActiveWin).Y - Windows(ActiveWin).DataOffH + 11 THEN
	       
    IF MouseX > Windows(ActiveWin).X + Windows(ActiveWin).DataOffX AND MouseX < Windows(ActiveWin).X + Windows(ActiveWin).DataOffX + 11 THEN
     'Clicked on Left
     Windows(ActiveWin).ViewX = Windows(ActiveWin).ViewX - 32
     IF Windows(ActiveWin).ViewX < 0 THEN Windows(ActiveWin).ViewX = 0
    END IF

    IF MouseX < Windows(ActiveWin).X + Windows(ActiveWin).W - Windows(ActiveWin).DataOffW AND MouseX > Windows(ActiveWin).X + Windows(ActiveWin).W - Windows(ActiveWin).DataOffW - 10 THEN
     'Clicked on Right
     Windows(ActiveWin).ViewX = Windows(ActiveWin).ViewX + 32
     IF Windows(ActiveWin).ViewX > Windows(ActiveWin).RealX - ViewX THEN Windows(ActiveWin).ViewX = Windows(ActiveWin).RealX - ViewX
    END IF

    IF MouseX > Windows(ActiveWin).X + Windows(ActiveWin).DataOffX + 13 AND MouseX < BarLenX + Windows(ActiveWin).X + Windows(ActiveWin).DataOffX + 17 THEN
     MouseDo = 3
     EXIT SUB
    END IF
   
   END IF
  END IF

 'If Scroll Y axis clicked on then update
  IF (Windows(ActiveWin).Properties AND ScrollY + MiniMised) = ScrollY THEN
   
   BarLenY = (Windows(ActiveWin).H + Windows(ActiveWin).Y - Windows(ActiveWin).DataOffH - 14) - (Windows(ActiveWin).Y + Windows(ActiveWin).DataOffY + 13) - 4
   ViewY = (Windows(ActiveWin).H + Windows(ActiveWin).Y - Windows(ActiveWin).DataOffH) - (Windows(ActiveWin).Y + Windows(ActiveWin).DataOffY)
   ScrollLenY = (ViewY / Windows(ActiveWin).RealY) * BarLenY
   ScrollViewY = (Windows(ActiveWin).ViewY / Windows(ActiveWin).RealY) * BarLenY

   Tx = Windows(ActiveWin).X + Windows(ActiveWin).W - Windows(ActiveWin).DataOffW + 11
   IF MouseX > Tx - 9 AND MouseX < Tx THEN
    
    IF MouseY > Windows(ActiveWin).Y + Windows(ActiveWin).DataOffY AND MouseY < Windows(ActiveWin).Y + Windows(ActiveWin).DataOffY + 11 THEN
     'Clicked on Up
     Windows(ActiveWin).ViewY = Windows(ActiveWin).ViewY - 32
     IF Windows(ActiveWin).ViewY < 0 THEN Windows(ActiveWin).ViewY = 0
    END IF
  
    IF MouseY < Windows(ActiveWin).H + Windows(ActiveWin).Y - Windows(ActiveWin).DataOffH AND MouseY > Windows(ActiveWin).H + Windows(ActiveWin).Y - Windows(ActiveWin).DataOffH - 12 THEN
     'Clicked on Down
     Windows(ActiveWin).ViewY = Windows(ActiveWin).ViewY + 32
    END IF

    IF MouseY > Windows(ActiveWin).Y + Windows(ActiveWin).DataOffY + 13 AND MouseY < BarLenY + Windows(ActiveWin).Y + Windows(ActiveWin).DataOffY + 17 THEN
     MouseDo = 4
     EXIT SUB
    END IF
    
    END IF
   END IF
 END IF

 IF (Windows(ActiveWin).Properties AND TitleBar) = TitleBar AND (MouseX <> OldMouseX OR MouseY <> OldMouseY) THEN
  IF (MouseY > Windows(ActiveWin).Y + 5 AND MouseY < Windows(ActiveWin).Y + 20) THEN

    'Mini
    IF MouseX > Windows(ActiveWin).W + Windows(ActiveWin).X - 48 AND MouseX < Windows(ActiveWin).W + Windows(ActiveWin).X - 37 THEN
     IF MouseY > Windows(ActiveWin).Y + 7 AND MouseY < Windows(ActiveWin).Y + 18 THEN
      IF (Windows(ActiveWin).Properties AND Minimise) = Minimise THEN
       DrawToolTip Windows(ActiveWin).X, Windows(ActiveWin).Y - 18, "Minimise"
       EXIT SUB
      END IF
     END IF
    END IF

    'Maxi
    IF MouseX > Windows(ActiveWin).W + Windows(ActiveWin).X - 34 AND MouseX < Windows(ActiveWin).W + Windows(ActiveWin).X - 23 THEN
     IF MouseY > Windows(ActiveWin).Y + 7 AND MouseY < Windows(ActiveWin).Y + 18 THEN
      IF (Windows(ActiveWin).Properties AND Maximise) = Maximise THEN
       DrawToolTip Windows(ActiveWin).X, Windows(ActiveWin).Y - 19, "Maxmise"
       EXIT SUB
      END IF
     END IF
    END IF

    'Close
    IF MouseX > Windows(ActiveWin).W + Windows(ActiveWin).X - 18 AND MouseX < Windows(ActiveWin).W + Windows(ActiveWin).X - 7 THEN
     IF MouseY > Windows(ActiveWin).Y + 7 AND MouseY < Windows(ActiveWin).Y + 18 THEN
      IF (Windows(ActiveWin).Properties AND CloseWin) = CloseWin THEN
       DrawToolTip Windows(ActiveWin).X, Windows(ActiveWin).Y - 20, "Close"
       EXIT SUB
      END IF
     END IF
    END IF

    DrawToolTip Windows(ActiveWin).X, Windows(ActiveWin).Y - 20, "Move Window"
    EXIT SUB

   END IF
  END IF

'Redraw Window before testing Objects
IF ActiveWin <> OldActiveWin THEN EXIT SUB

' =-=-=-=-=-=-=-=[ END OF WINDOW CHECK. START OBJECT CHECK ]=-=-=-=-=-=-=-=-=-=-=-=-

' Setup Checking Area

IF MouseX > Windows(ActiveWin).X + Windows(ActiveWin).DataOffX AND MouseX < Windows(ActiveWin).X + Windows(ActiveWin).W - Windows(ActiveWin).DataOffW AND MouseY > Windows(ActiveWin).Y + Windows(ActiveWin).DataOffY AND MouseY < Windows(ActiveWin).H + _
 Windows(ActiveWin).Y - Windows(ActiveWin).DataOffH THEN

OldSel = Selected
Selected = 0
IF MouseX <> OldMouseX OR MouseY <> OldMouseY OR OldClick <> Click OR ABS(Click) > 10 OR OldKey$ <> KBD$ THEN
A = Windows(ActiveWin).Obj1st

DO
 ObjRanges A
 IF MouseX > Sx AND MouseY > Sy AND MouseX < Sx1 AND MouseY < Sy1 THEN
  Selected = 1
  OldObj = ObjActive
  ObjActive = A
  Old2 = ObjReturn
  ObjReturn = Click

  SELECT CASE Objects(A).Style
  CASE 21
   IF Click <> 0 THEN
    ChangeObject A, 0, 0, Sx1 + 4, 0, 0, "", 0, 0, 20, "", 260
    DO UNTIL Future.MouseB = 0: LOOP
   END IF
  
  CASE 4, 5
   IF (MouseX <> OldMouseX OR MouseY <> OldMouseY) AND (A <> ObjActive) OR (Click <> 0) THEN
    IF Click = 1 THEN
     IF Objects(A).Style = 5 THEN
      FOR S = 0 TO MaxObjects
       IF (Objects(S).Style = 5) AND (Objects(S).Properties AND Exist) = Exist AND (Objects(S).ID = Objects(A).ID) AND (Objects(S).Flags <> 0) THEN
	Objects(S).Flags = 0
	ObjectDraw S
       END IF
      NEXT
     END IF
    Objects(A).Flags = Objects(A).Flags XOR 1
    END IF
   END IF

  CASE 6, 20 'Pull Menu
   ObjReturn = ((MouseY - Sy) / 16) + .5
   
   IF (Click <> 0) AND Objects(A).Style = 20 THEN
    ChangeObject A, 0, 0, Sx1 - Sx, 20, 0, "", ObjReturn, 0, 21, "", 332
    Win = Objects(A).WinIndex
    ReSizeWinBuf Win
    ReDrawArea Windows(Win).X, Windows(Win).Y, Windows(Win).W, Windows(Win).H, Win
    DO UNTIL Future.MouseB = 0: LOOP
   END IF
   
  CASE 7 'Slider Bar (Vertical)
   IF (MouseX <> OldMouseX OR MouseY <> OldMouseY) AND (Click <> 0) THEN
    Objects(A).Flags = Sy1 - MouseY - 8
    IF Objects(A).Flags < 1 THEN Objects(A).Flags = 1
    IF Objects(A).Flags > Objects(A).H THEN Objects(A).Flags = Objects(A).H
   END IF
   ObjReturn = Objects(A).Flags

  CASE 8 ' Number Box
   Old2 = Objects(A).Flags
   SELECT CASE MouseX
    CASE IS < Sx + 16
     IF Click = 1 OR Click > 30 THEN Objects(A).Flags = Objects(A).Flags - Objects(A).ID
    
    CASE IS > Sx + 62
     IF Click = 1 OR Click > 30 THEN Objects(A).Flags = Objects(A).Flags + Objects(A).ID
     
    CASE ELSE
     P$ = STR$(Objects(A).Flags) 'Buffer in the crap
     IF KBD$ <> "" THEN
      IsKey = 1
      SELECT CASE ASC(KBD$)
       CASE 8
	IF LEN(P$) > 0 THEN P$ = MID$(P$, 1, LEN(P$) - 1)
       CASE 48 TO 59, 45
	P$ = P$ + RIGHT$(KBD$, 1)
       CASE 27
	P$ = ""
       CASE ELSE
      END SELECT
     Objects(A).Flags = VAL(P$) MOD 32766
     END IF
   END SELECT
   IF Objects(A).Flags < Objects(A).W THEN Objects(A).Flags = Objects(A).W
   IF Objects(A).Flags > Objects(A).H THEN Objects(A).Flags = Objects(A).H
   ObjReturn = Objects(A).Flags

  CASE 9, 18'Create Text Box
  SELECT CASE MouseY
   CASE IS < Sy + 15
    Tmp$ = "Click to Scroll Up"
    IF Click <> 0 THEN Objects(A).Flags = Objects(A).Flags - 1
    
   CASE IS > Sy1 - 15
    Tmp$ = "Click to Scroll Down"
    IF Click <> 0 THEN
     Objects(A).Flags = Objects(A).Flags + 1
     Tmp = ((Sy1 - Sy) - 34) \ 16
     IF Objects(A).Flags > Objects(A).ToolPtr + 1 - Tmp THEN Objects(A).Flags = Objects(A).ToolPtr + 1 - Tmp
    END IF

   CASE ELSE
    Tmp$ = "TextBox"
    IF Objects(A).Style = 9 THEN
     Tmp$ = "Edit the text using the keyboard"
     Temp = Objects(A).ID
     T2 = Temp
     t$ = TextBuf$(Objects(A).TextPtr)
     TextBuf$(Objects(A).TextPtr) = Inputs$(TextBuf$(Objects(A).TextPtr), Temp)
     IF (Temp <> T2) OR (t$ <> TextBuf$(Objects(A).TextPtr)) THEN
      'Input entered
      Objects(A).ID = Temp
      FOR S = 1 TO LEN(TextBuf$(Objects(A).TextPtr))
       Data1$ = GetLineWrap$(TextBuf$(Objects(A).TextPtr), S, Objects(A).W - 4)
       S = S + LEN(Data1$)
       D = D + 1
       IF G = 0 AND S > Temp THEN G = D
      NEXT
      Objects(A).ToolPtr = D
      Objects(A).Flags = G - 5
     END IF
    END IF
  END SELECT
  DrawToolTip Sx, Sy - 20, Tmp$
  IF Objects(A).Flags < 0 THEN Objects(A).Flags = 0
  ObjReturn = Objects(A).Flags

  CASE 11
   ObjReturn = (MouseX - Sx) / (8 * Objects(A).Flags) + .5
   
  CASE 14, 15, 16'Pictures
   MPosX = MouseX - Sx
   MPosY = MouseY - Sy
  
  CASE 17 'Text Input
   Temp = Objects(A).Flags
   T2 = Temp
   t$ = TextBuf$(Objects(A).TextPtr)
   TextBuf$(Objects(A).TextPtr) = Inputs$(TextBuf$(Objects(A).TextPtr), Temp)
   IF (Temp <> T2) OR (t$ <> TextBuf$(Objects(A).TextPtr)) THEN
    Objects(A).Flags = Temp
    IF Objects(A).Flags < 0 THEN Objects(A).Flags = 0
   END IF
   ObjReturn = Objects(A).Flags

  CASE ELSE
  END SELECT

  IF (MouseX <> OldMouseX OR MouseY <> OldMouseY) OR (Old2 <> ObjReturn) OR (OldObj <> ObjActive) THEN
   ObjectDraw OldObj
   ObjectDraw A
  END IF
  EXIT DO
 END IF
 A = Objects(A).Nxt
LOOP WHILE A <> Windows(ActiveWin).Obj1st

 IF (Selected = 0) OR (OldSel <> Selected) OR (OldObj <> ActiveObj) THEN
  ObjectDraw ObjActive
  ReFreshObject ObjActive
  IF (Objects(A).Style MOD 9 <> 0) THEN DrawToolTip Sx, Sy - 20, TextBuf$(Objects(A).ToolPtr)
 END IF

 IF (Selected = 0) AND (OldObj <> ActiveObj) THEN
  ReDrawArea ToolX, ToolY, ToolW, ToolH, -1
 END IF

END IF
END IF
END SUB

SUB DrawBox3D (X, Y, X1, Y1, Col&, Col2&, Grad)

IF BytePx > 1 THEN
 IF Col2& = Col& THEN
  Future.FILLBOX X, Y, X1, Y1, Col&
 ELSE
  IF Grad <> 0 THEN GradVertFill X, Y, X1, Y1, Col&, Col2&, ABS(Grad)
 END IF
ELSE
 IF Col2& = Col& THEN
  Future.FILLBOX X, Y, X1, Y1, Col2&
 ELSE
  IF Grad <> 0 THEN Future.FILLBOX X, Y, X1, Y1, Col2&
 END IF
END IF

SetBlender 128
Future.LINE X, Y, X, Y1, Colors(5), -1
Future.HLINE Y, X, X1, Colors(5)
Future.HLINE Y1, X1, X, Colors(6)
Future.LINE X1, Y1, X1, Y, Colors(6), -1
SetBlender 0

END SUB

SUB DrawObjects (Win)

A = Windows(Win).Obj1st
 DO
  ObjectDraw A
  A = Objects(A).Nxt
 LOOP WHILE A <> Windows(Win).Obj1st

EXIT SUB

END SUB

SUB DrawScrollX (X1, Y1, X2, Y2, ViewX, XReal, Xpos)

   BarLenX = (X2 - 12) - (X1 + 13) - 4
   ScrollLenX = (ViewX / XReal) * BarLenX
   ScrollViewX = (Xpos / XReal) * BarLenX

   DrawBox3D X1, Y2, X1 + 11, Y1, Colors(8), Colors(7), 0
   DrawBox3D X2, Y2, X2 - 10, Y1, Colors(8), Colors(7), 0
   DrawBox3D X1 + 13, Y2, BarLenX + X1 + 17, Y1, Colors(TitleText), 1, 0

   Tx = X1 + 15 + ScrollViewX
   dx = Tx

   DrawBox3D Tx, Y1 + 2, Tx + ScrollLenX, Y2 - 2, Colors(8), Colors(Title), 4
   Future.PRINT X1 + 2, Y1, CHR$(17), Colors(TitleText), -1
   Future.PRINT X2 - 8, Y1, CHR$(16), Colors(TitleText), -1

END SUB

SUB DrawScrollY (X1, Y1, X2, Y2, ViewY, YReal, Ypos)
 
   BarLenY = (Y2 - 14) - (Y1 + 13) - 4
   ScrollLenY = (ViewY / YReal) * BarLenY
   ScrollViewY = (Ypos / YReal) * BarLenY

   DrawBox3D X2, Y1, X1, Y1 + 11, Colors(8), Colors(7), 0
   DrawBox3D X2, Y2, X1, Y2 - 12, Colors(8), Colors(7), 0
   DrawBox3D X2, 4 + BarLenY + Y1 + 13, X1, Y1 + 13, Colors(TitleText), 1, 0

   Ty = Y1 + 15 + ScrollViewY
   
   DrawBox3D X1 + 2, Ty, X1 + 7, Ty - 2 + ScrollLenY, Colors(8), Colors(Title), BytePx * 5
   Future.PRINT X1 + 1, Y1, CHR$(30), Colors(TitleText), -1
   Future.PRINT X1 + 1, Y2 - 12, CHR$(31), Colors(TitleText), -1
 
END SUB

SUB DrawToolTip (X, Y, Text$)

IF Text$ <> ToolTXT$ THEN

 'Clear old Toolbox
 ReDrawArea ToolX, ToolY, ToolW, ToolH, -1

 IF Text$ = "" THEN EXIT SUB
 ToolTXT$ = Text$

 'Define Sizes
 ToolW = 8 + (LEN(Text$) * 8)
 ToolH = 20
 
 'Check to make ToolTip on Screen
  IF X < 0 THEN
   ToolX = 0
  ELSE
   IF X + ToolW > ResX THEN
    ToolX = ResX - ToolW
   ELSE
    ToolX = X
   END IF
  END IF

  IF Y < 0 THEN
   ToolY = 0
  ELSE
   IF Y + ToolH > ResY THEN
    ToolY = ResY - ToolH
   ELSE
    ToolY = Y
   END IF
  END IF
 
 SetBlender 128
 DrawBox3D ToolX, ToolY, ToolX + ToolW, ToolY + ToolH, Colors(11), Colors(11), 1
 SetBlender 60
 Future.PRINT ToolX + 7, ToolY + 7, Text$, 0, -1
 SetBlender 0
 Future.PRINT ToolX + 4, ToolY + 4, Text$, Colors(5), -1
END IF

END SUB

SUB DrawWindow (Win)

IF Windows(Win).Properties AND Exist THEN

 SetCols Win
 CheckScroll Win

DefineEMSbufferSize Windows(Win).Handle, Windows(Win).W, Windows(Win).H, 0

 SetEMSpage 0
 
IF Win = Win1st THEN
 Future.XMSput 0, 0, Scr
ELSE
 
 DrawBox3D 0, 0, Windows(Win).W, Windows(Win).H, Colors(Button), Colors(WinCol), BytePx * 13
 DrawBox3D Windows(Win).DataOffX, Windows(Win).DataOffY, Windows(Win).W - Windows(Win).DataOffW, Windows(Win).H - Windows(Win).DataOffH, 0, 1, 0
 
 IF (Windows(Win).Properties AND Resizeable) = Resizeable THEN
  DrawBox3D 4, 4, Windows(Win).W - 4, Windows(Win).H - 4, 0, 1, 0
 END IF

 IF (Windows(Win).Properties AND TitleBar) = TitleBar THEN
  DrawBox3D 5, 5, Windows(Win).W - 5, 20, Colors(Title), Colors(0), BytePx * 4
  Future.PRINT 10, 6, TextBuf$(Windows(Win).TextPtr), Colors(TitleText), -1
 END IF

 IF (Windows(Win).Properties AND CloseWin + TitleBar) = CloseWin + TitleBar THEN
  DrawBox3D Windows(Win).W - 18, 7, Windows(Win).W - 7, 18, Colors(Title), Colors(Button), 5
  SetBlender 128
  Future.PRINT Windows(Win).W - 15, 6, "x", FindNearCol(255, 255, 255), -1
  Future.PRINT Windows(Win).W - 16, 5, "x", 0, -1
  SetBlender 0
 END IF

 IF (Windows(Win).Properties AND Maximise + TitleBar) = Maximise + TitleBar THEN

  IF (Windows(Win).Properties AND MiniMised) = 0 THEN
   DrawBox3D Windows(Win).W - 34, 7, Windows(Win).W - 23, 18, Colors(Title), Colors(Button), 5
  END IF

  IF (Windows(Win).Properties AND MaxiMised) = 0 THEN P$ = CHR$(30) ELSE P$ = "="
   SetBlender 128
   Future.PRINT Windows(Win).W - 31, 7, P$, FindNearCol(255, 255, 255), -1
   Future.PRINT Windows(Win).W - 32, 6, P$, 0, -1
   SetBlender 0
  END IF

 IF (Windows(Win).Properties AND Minimise + TitleBar) = Minimise + TitleBar THEN

  IF (Windows(Win).Properties AND MaxiMised) = 0 THEN
   DrawBox3D Windows(Win).W - 48, 7, Windows(Win).W - 37, 18, Colors(Title), Colors(Button), 5
  END IF

  IF (Windows(Win).Properties AND MiniMised) = 0 THEN P$ = CHR$(31) ELSE P$ = CHR$(127)
   SetBlender 128
   Future.PRINT Windows(Win).W - 45, 7, P$, FindNearCol(255, 255, 255), -1
   Future.PRINT Windows(Win).W - 46, 6, P$, 0, -1
   SetBlender 0
  END IF

 END IF
 SetPage 0

END IF
Windows(Win).Properties = Windows(Win).Properties OR Dirty

END SUB

SUB DrawWindows

A = WinPtr
DO
 DrawWindow A
 DrawWinScroll A
 DrawObjects A
 A = Windows(A).Nxt
LOOP WHILE A <> WinPtr

ReDrawArea 0, 0, ResX, ResY, -1

END SUB

SUB DrawWinScroll (Win)

DefineEMSbufferSize Windows(Win).Handle, Windows(Win).W, Windows(Win).H, 0
SetEMSpage 0

 IF (Windows(Win).Properties AND ScrollY + MiniMised) = ScrollY THEN
  DrawScrollY Windows(Win).W + 11 - Windows(Win).DataOffW - 9, Windows(Win).DataOffY, Windows(Win).W + 11 - Windows(Win).DataOffW, Windows(Win).H - Windows(Win).DataOffH, (Windows(Win).H - Windows(Win).DataOffH) - Windows(Win).DataOffY, Windows(Win) _
.RealY, Windows(Win).ViewY
 END IF

 IF (Windows(Win).Properties AND ScrollX + MiniMised) = ScrollX THEN
  DrawScrollX Windows(Win).DataOffX, Windows(Win).H - Windows(Win).DataOffH + 2, Windows(Win).W - Windows(Win).DataOffW, Windows(Win).H - Windows(Win).DataOffH + 11, (Windows(Win).H - Windows(Win).DataOffH) - (Windows(Win).DataOffY), Windows(Win). _
RealX, Windows(Win).ViewX
 END IF
SetPage 0
Windows(Win).Properties = Windows(Win).Properties OR Dirty
END SUB

SUB ExitGUI

Selected = 0

  A = WinPtr
  DO
   CloseWindow A
   A = Windows(A).Nxt
  LOOP WHILE A <> WinPtr

DeallocateXMS Scr
ERASE Buttons, Windows, Objects, TextBuf$, Colors, Regions
Resetscreen
END SUB

FUNCTION FindNearCol& (R, G, B)

IF BytePx > 1 THEN
 FindNearCol = RGB2Color(R, G, B)
ELSE
 RR = (R \ 4 \ RS)
 GG = (G \ 4 \ GS)
 BB = (B \ 4 \ BS)
 FindNearCol = (RR * 32) + (GG * 4) + BB
END IF

END FUNCTION

FUNCTION GetLineWrap$ (Text$, StartPoint, Wid)

Lener = 0
WordsAline = 0
LastSpace = 0

FOR A = StartX TO Wid
 P$ = MID$(Text$, StartPoint + A, 1)
 Lener = Lener + 8
 IF P$ = " " THEN
  OldLener = Lener
  WordsAline = WordsAline + 1
  LastSpace = A
 END IF
 IF Lener > (Wid - StartX) THEN EXIT FOR
NEXT

P$ = ""

IF WordsAline = 0 AND LastSpace < StartPoint THEN
 'Cannot fit on a line so add hy-phen
 'Not Working
 FOR A = 0 TO A - 2
  P$ = P$ + MID$(Text$, StartPoint + A, 1)
 NEXT
 P$ = P$ + "- "
 Q$ = RIGHT$(Text$, ABS(LEN(Text$) - A))
ELSE
 P$ = ""
 FOR A = 0 TO LastSpace
  P$ = P$ + MID$(Text$, StartPoint + A, 1)
 NEXT
 Q$ = RIGHT$(Text$, LEN(Text$) - A)
END IF

IF WordsAline < 1 THEN WordsAline = 1
Spacing = ((Wid - StartX) - Lener) \ WordsAline
GetLineWrap$ = LEFT$(P$, LEN(P$) - 1)

END FUNCTION

SUB GradHorzFill (X, Y, X1, Y1, Left&, Right&, z)

IF ABS(X1 - X) < 2 THEN EXIT SUB
Color2RGB Left&, R1, G1, B1
Color2RGB Right&, R2, G2, B2
S = 0
Stepin! = ABS((X1 - X) / z)

FOR A! = X TO X1 - Stepin! STEP Stepin!
 S = S + 1
 D! = (z - S) / z
 C! = (S / z)
 R = (R2 * C!) + (R1 * D!)
 G = (G2 * C!) + (G1 * D!)
 B = (B2 * C!) + (B1 * D!)
 Future.FILLBOX A!, Y, A! + Stepin!, Y1, RGB2Color(R, G, B)
NEXT
Future.FILLBOX A!, Y, X1, Y1, Right&

END SUB

SUB GradVertFill (X, Y, X1, Y1, Left&, Right&, z)

IF Y1 - Y < 2 THEN EXIT SUB
Color2RGB Left&, R1, G1, B1
Color2RGB Right&, R2, G2, B2
Stepin! = ABS((Y1 - Y) / z)
S = 0

FOR A! = Y TO Y1 - Stepin! STEP Stepin!

S = S + 1
D! = (z - S) / z

R = R2 + (R1 - R2) * D!
G = G2 + (G1 - G2) * D!
B = B2 + (B1 - B2) * D!

D = A! + Stepin!
IF D = INT(A!) THEN A! = A! + 1
Future.FILLBOX X, A!, X1, D, FindNearCol(R, G, B)
NEXT

Future.FILLBOX X, A!, X1, Y1, Right&
END SUB

FUNCTION InitGUI (MaxWin, MaxObj, MaxTxt, ColorScheme$, BackDrop$, Fonts$, X, Y, Bpp)

'System Check
IF IsVESA = False OR IsEMMInstalled = False OR IsXMSInstalled = False THEN PRINT "A Service was not Found -:- Exit": SYSTEM

MaxWindows = MaxWin
MaxObjects = MaxObj
TextBuffer = MaxTxt
ResX = X
ResY = Y
BytePx = CINT(Bpp / 8)

SetScreenMode ResX, ResY, Bpp
REDIM Buttons(SizeOf(14, 14), 3), Windows(MaxWindows) AS Win, Objects(MaxObjects) AS Object, TextBuf$(TextBuffer), Regions(MaxWindows * 8)   AS Region

Scr = AllocateXMS(SizeOf(ResX + 1, ResY + 1))
IF Bpp > 8 THEN
 IF (BackDrop$ <> "") OR (INSTR(BackDrop$, "PCX") <> 0) THEN
  Future.LoadPCX BackDrop$, 0, 0
 END IF
ELSE
 'Create a Good 3-3-2 Palette
 FOR R = 0 TO 63 STEP 63 \ 7
  FOR G = 0 TO 63 STEP 63 \ 7
   FOR B = 0 TO 63 STEP 63 \ 3
    OUT &H3C9, R
    OUT &H3C9, G
    OUT &H3C9, B
   NEXT
  NEXT
 NEXT
END IF

Future.XMSget 0, 0, ResX - 1, ResY - 1, Scr
LoadColorScheme ColorScheme$
LoadButtons

Future.LoadFONT Fonts$

Win1st = CreateNewWindow(0, 0, ResX - 1, ResY - 1, Desktop, ResX - 1, ResY - 1, 0, 0, "")
Future.MouseOn
InitGUI = -1
END FUNCTION

FUNCTION Inputs$ (S$, Ptr)
IF Ptr > LEN(S$) THEN Ptr = LEN(S$)

P$ = LEFT$(S$, Ptr)
Q$ = RIGHT$(S$, LEN(S$) - Ptr)
D$ = ""

IF KBD$ <> "" THEN
  IsKey = 1
  
  IF ASC(LEFT$(KBD$, 1)) = 0 THEN
   SELECT CASE ASC(RIGHT$(KBD$, 1))

  CASE 77 'Right
   Ptr = Ptr + 1
   IF Ptr > LEN(S$) THEN Ptr = LEN(S$)

  CASE 75 'Left
   Ptr = Ptr - 1
   IF Ptr < 0 THEN Ptr = 0

  CASE 83 'Delete
   IF LEN(Q$) > 0 THEN Q$ = RIGHT$(Q$, LEN(Q$) - 1)
  
  CASE 71
   Ptr = 0

  CASE 79
   Ptr = LEN(S$)

  CASE 115 'Ctrl Left
   FOR A = Ptr TO 1 STEP -1
    F$ = MID$(P$, A, 1)
    IF F$ = " " THEN EXIT FOR
    D$ = D$ + F$
   NEXT
   Ptr = Ptr - LEN(D$) - 1
   IF Ptr < 0 THEN Ptr = 0

  CASE 116 'Ctrl Right
   FOR A = 1 TO LEN(Q$)
    F$ = MID$(Q$, A, 1)
    IF F$ = " " THEN EXIT FOR
    D$ = D$ + F$
   NEXT
   Ptr = Ptr + LEN(D$) + 1
   IF Ptr > LEN(S$) THEN Ptr = LEN(S$)

  CASE ELSE
  END SELECT

  ELSE

  SELECT CASE ASC(KBD$)
  CASE 13
   Var$ = P$
   P$ = ""
   Ptr = 0
   EXIT FUNCTION
  CASE 8
   IF LEN(P$) > 0 THEN
    P$ = LEFT$(P$, LEN(P$) - 1)
    Ptr = Ptr - 1
   END IF

  CASE 32 TO 128
   P$ = P$ + RIGHT$(KBD$, 1)
   Ptr = Ptr + 1
  CASE 27
   Ptr = 0

   EXIT FUNCTION
  END SELECT

  END IF

 END IF

 Inputs$ = P$ + Q$
 Temp = Ptr
END FUNCTION

FUNCTION InTextBuffer (Text$, Num)

IF Text$ = "" THEN EXIT FUNCTION

 IF Num < 0 THEN
  FOR B = 1 TO TextBuffer
   IF TextBuf$(B) = "" THEN
    TextBuf$(B) = Text$
    InTextBuffer = B
    EXIT FOR
   END IF
  NEXT
 ELSE
  IF Num < TextBuffer THEN
   TextBuf$(Num) = Text$
   InTextBuffer = Num
  ELSE
   InTextBuffer = -1
  END IF
 END IF

END FUNCTION

FUNCTION IsObject (ObjNum, Min, Max)
 IF Selected THEN
  IF ObjNum = ObjActive THEN
   IF Objects(ObjNum).WinIndex = ActiveWin THEN
    IF ObjReturn >= Min AND ObjReturn <= Max THEN
     IsObject = ObjReturn
    END IF
   END IF
  END IF
 END IF
END FUNCTION

SUB LoadButtons
'Load Buttons for use in GUI

IF BytePx = 1 OR BytePx = 3 THEN
 Future.FILLBOX 1, 1, 14, 14, Colors(12)
 Future.BOX 1, 1, 14, 14, Colors(3)
 Future.DirectGET 1, 1, 14, 14, VARPTR(Buttons(0, 2)), VARSEG(Buttons(0, 2))
 Future.DirectGET 1, 1, 14, 14, VARPTR(Buttons(0, 0)), VARSEG(Buttons(0, 0))
 Future.FILLBOX 5, 5, 10, 10, Colors(3)
 Future.DirectGET 1, 1, 14, 14, VARPTR(Buttons(0, 1)), VARSEG(Buttons(0, 1))
 Future.DirectPut 1, 1, VARPTR(Buttons(0, 2)), VARSEG(Buttons(0, 2))
 Future.LINE 1, 1, 14, 14, Colors(3), -1
 Future.LINE 14, 1, 1, 14, Colors(3), -1
 Future.DirectGET 1, 1, 14, 14, VARPTR(Buttons(0, 3)), VARSEG(Buttons(0, 3))
ELSE
 DIM But$(4)
 But$(0) = "Data\RadioOff"
 But$(1) = "Data\RadioOn"
 But$(2) = "Data\CheckOff"
 But$(3) = "Data\CheckOn"
 But$(4) = "Data\Mask"

 FOR A = 4 TO 0 STEP -1
  Future.FILLBOX 0, 0, 14, 14, 0
  Future.LoadBMP But$(A), 1, 1
  SetBlender 100
  Future.FILLBOX 0, 0, 14, 14, Colors(3)
  SetBlender 0
  IF A = 4 THEN
   WinMaskCol = Future.POINT(3, 3)
  ELSE
   Future.DirectGET 1, 1, 14, 14, VARPTR(Buttons(0, A)), VARSEG(Buttons(0, A))
  END IF
 NEXT
 SetMaskColor -1
END IF
END SUB

SUB LoadColorScheme (File$)
'Load a Color Scheme

Free = FREEFILE
OPEN File$ FOR INPUT AS Free
FOR A = 0 TO 15
 INPUT #Free, R, G, B
 Colors(A) = FindNearCol(R, G, B)
NEXT
CLOSE Free

END SUB

FUNCTION LoadWinResources (Win, File$)

' Loads Forms into a a specific Window

' Destroy all old components
' Load File in to component Buffer
' Adjust window properties


END FUNCTION

SUB MakeWindowActive (WindowNum)

S = 0
Selected = 0
D = 0
Old = ActiveWin
A = WinPtr
 DO
  IF WindowNum = A THEN S = D
  A = Windows(A).Nxt
  D = D + 1
 LOOP WHILE A <> WinPtr

Shuffle S, 0
ActiveWin = WindowNum

DrawWindow Old
DrawWinScroll Old
DrawObjects Old
ReDrawArea Windows(Old).X, Windows(Old).Y, Windows(Old).W, Windows(Old).H, Old

DrawWindow ActiveWin
DrawWinScroll ActiveWin
DrawObjects ActiveWin
ReDrawArea Windows(ActiveWin).X, Windows(ActiveWin).Y, Windows(ActiveWin).W, Windows(ActiveWin).H, ActiveWin

END SUB

SUB ObjectDraw (A)

' If Object Exist
IF (Objects(A).Properties AND Exist) = Exist AND (Windows(Win).Properties AND MiniMised) = 0 THEN

'Get Window Number ....
Win = Objects(A).WinIndex
SetCols Win
DefineEMSbufferSize Windows(Win).Handle, Windows(Win).W, Windows(Win).H, 0
SetEMSpage 0

 'Set Cor ranges for Window
 XX = Windows(Win).DataOffX
 YY = Windows(Win).DataOffY
 XX1 = Windows(Win).W - Windows(Win).DataOffW
 YY1 = Windows(Win).H - Windows(Win).DataOffH

 SetViewPort XX + 1, YY + 1, XX1, YY1

 'Set Color
 IF ObjActive = A AND Selected <> 0 THEN ObjSelect& = Colors(TitleText) ELSE ObjSelect& = Colors(Button)
 
 ObjRanges A
 IF Collide(Windows(Win).X + XX, Windows(Win).Y + YY, XX1, YY1, Sx, Sy, Sx1 - Sx, Sy1 - Sy) THEN
 'IF P = P THEN
 IF Objects(A).WinIndex = Win AND (Objects(A).Properties AND Exist) = Exist AND (Windows(Win).Properties AND MiniMised) = 0 THEN
  
  'Exist on Window, let go. See what Object it is
   Ex = XX + Objects(A).X - Windows(Win).ViewX
   Ey = YY + Objects(A).Y - Windows(Win).ViewY
   Ex1 = Ex + Objects(A).W + 1
   Ey1 = Ey + Objects(A).H + 1

  SELECT CASE Objects(A).Style

  CASE 1, 21'Push Button
   Future.BOX Ex - 1, Ey - 1, Ex1, Ey1, ObjSelect&
   DrawBox3D Ex, Ey, Ex1 - 1, Ey1 - 1, Colors(4), Colors(Menu), BytePx * 5

   IF Objects(A).Style = 21 THEN
    t$ = MID$(TextBuf$(Objects(A).TextPtr), (Objects(A).ID - 1) * Objects(A).Flags + 1, Objects(A).Flags)
   ELSE
    t$ = TextBuf$(Objects(A).TextPtr)
   END IF
   Lener = LEN(t$) * 8
   Xxx = (((Ex1 - Ex) - Lener) \ 2)
   IF Xxx < 1 THEN Xxx = 1
   IF ObjReturn AND A = ObjActive THEN Offset = 1
   Future.PRINT Ex + Xxx + Offset, Ey + ((Objects(A).H - 8) \ 2) + Offset, t$, Colors(Text), -1

  CASE 2 'Text
   Future.PRINT Ex, Ey, TextBuf$(Objects(A).TextPtr), Colors(Text), -1
   
  CASE 3 'ProgressBar
   Bar = (Ex1 - Ex) * (Objects(A).Flags / 100)
   DrawBox3D Ex + Bar - 1, Ey, Ex1 - 1, Ey1 - 1, Colors(Button), Colors(Button), 0
   DrawBox3D Ex, Ey, Ex + Bar, Ey1 - 1, Colors(8), Colors(Title), 20
   t$ = STR$(Objects(A).Flags) + "%"
   Lener = LEN(t$) * 8
   Xxx = (((Ex1 - Ex) - Lener) \ 2)
   IF Xxx < 1 THEN Xxx = 1
   Future.PRINT Ex + Xxx, Ey + ((Objects(A).H - 8) \ 2), t$, Colors(Text), -1
   
  CASE 4, 5 'Check Boxes
   IF Objects(A).Style = 5 THEN SetMaskColor WinMaskCol
   Objects(A).Flags = SGN(Objects(A).Flags)
   Future.BOX Ex - 1, Ey - 1, Ex + 14, Ey + 14, ObjSelect&
   IF Objects(A).Style = 4 THEN R = 2 ELSE R = 0
   Future.DirectPut Ex, Ey, VARPTR(Buttons(0, R + Objects(A).Flags)), VARSEG(Buttons(0, R + Objects(A).Flags))
   Future.PRINT Ex + 20, Ey, TextBuf$(Objects(A).TextPtr), Colors(Text), -1
   SetMaskColor -1

  CASE 6, 20'Pull Menu
   'Flags has Len in Chars
   Lener = LEN(TextBuf$(Objects(A).TextPtr))
   E = (Lener \ Objects(A).Flags) + SGN(Lener MOD Objects(A).Flags)
   Height = E * 16
   Wide = (Objects(A).Flags + 1) * 8

    Future.BOX Ex - 1, Ey - 1, Ex + Wide + 5, Ey + Height + 5, ObjSelect&
    DrawBox3D Ex, Ey, Ex + Wide + 4, Ey + Height + 4, Colors(4), Colors(Menu), 4 * BytePx
    FOR B = 1 TO E
     C1& = -1
     C2& = Colors(TitleText)
     IF (B = ObjReturn) AND (A = ObjActive) AND (Selected <> 0) THEN SWAP C1&, C2&
     Texter$ = MID$(TextBuf$(Objects(A).TextPtr), ((B - 1) * Objects(A).Flags) + 1, Objects(A).Flags)
     Future.PRINT Ex + 4, Ey + ((B - 1) * 16) + 3, Texter$, C2&, C1&
    NEXT

  CASE 7 'Slider Bar (Vertical)
   DrawBox3D Ex - 8, Ey - 5, Ex1 + 8, Ey1 + 5, Colors(4), Colors(Menu), BytePx * 10
   Future.BOX Ex - 6, Ey1 - Objects(A).Flags - 3, Ex1 + 6, Ey1 - Objects(A).Flags + 3, ObjSelect&
   FOR B = Ey TO Ey1 STEP 10
    Future.HLINE B, Ex - 4, Ex1 + 3, Colors(Text)
   NEXT
   DrawBox3D Ex, Ey, Ex1 - 1, Ey1 - 1, Colors(Button), Colors(Button), 0
   SetBlender 128
   DrawBox3D Ex - 5, Ey1 - Objects(A).Flags - 2, Ex1 + 5, Ey1 - Objects(A).Flags + 2, Colors(Title), Colors(Title), 0
   SetBlender 0

  CASE 8 ' Number Box
   DrawBox3D Ex, Ey, Ex + 72, Ey + 16, Colors(4), Colors(Menu), BytePx * 3
   Future.BOX Ex - 1, Ey - 1, Ex + 73, Ey + 17, ObjSelect&

   DrawBox3D Ex, Ey, Ex + 10, Ey + 16, Colors(Title), 1, 0
   DrawBox3D Ex + 62, Ey, Ex + 72, Ey + 16, Colors(Title), 1, 0

   DrawBox3D Ex + 12, Ey, Ex + 60, Ey + 16, Colors(Title), 1, 0
   Future.PRINT Ex + 12, Ey + 2, STR$(Objects(A).Flags), Colors(Text), -1

   Future.PRINT Ex + 1, Ey + 2, CHR$(17), Colors(TitleText), -1
   Future.PRINT Ex + 63, Ey + 2, CHR$(16), Colors(TitleText), -1

  CASE 9, 18 'Create Text Box
   Future.BOX Ex - 1, Ey - 1, Ex1 + 1, Ey1 + 1, ObjSelect&
   DrawBox3D Ex, Ey, Ex1, Ey1, Colors(4), Colors(Menu), BytePx * 15
   Wide = (Ex1 - Ex) - 4
   Height = ((Ey1 - Ey) - 34) - 32
   FOR S = 1 TO LEN(TextBuf$(Objects(A).TextPtr))
    F = S + 1
    Data1$ = GetLineWrap$(TextBuf$(Objects(A).TextPtr), S, Wide)
    S = S + LEN(Data1$)
    J = J + 1
    IF Objects(A).Flags < J THEN
     Future.PRINT Ex + 2, Ey + 17 + D, Data1$, Colors(Text), -1
     IF (Objects(A).ID + 3 > F) AND (Objects(A).ID < S) AND (Objects(A).Style = 9) THEN
      Future.PRINT Ex + 2, Ey + 17 + D, Data1$, Colors(TitleText), -1
      G = (Objects(A).ID - F) * 8 + 16
      Future.LINE Ex + 2 + G, Ey + 17 + D, Ex + 2 + G, Ey + 17 + D + 16, Colors(TitleText), -1
     END IF
     IF D > Height THEN EXIT FOR
     D = D + 16
    END IF
   NEXT
   DrawBox3D Ex + 3, Ey + 2, Ex1 - 3, Ey + 15, Colors(Title), 1, 0
   DrawBox3D Ex + 3, Ey1 - 15, Ex1 - 3, Ey1 - 2, Colors(Title), 1, 0
   Future.PRINT Ex + ((Ex1 - Ex) \ 2), Ey + 2, CHR$(30), Colors(Text), -1
   Future.PRINT Ex + ((Ex1 - Ex) \ 2), Ey1 - 15, CHR$(31), Colors(Text), -1

  CASE 10
   DrawBox3D Ex, Ey, Ex1, Ey1, 1, 0, 0
  
  CASE 11 'Hoz Menu
   Lener = LEN(TextBuf$(Objects(A).TextPtr))
   E = (Lener \ Objects(A).Flags) + SGN(Lener MOD Objects(A).Flags)
   Wide = (Lener + 1) * 8
   DrawBox3D Ex, Ey, Ex + Wide + 4, Ey + 16 + 4, Colors(4), Colors(Menu), 4 * BytePx

   FOR B = 1 TO E
    C1& = -1
    C2& = Colors(TitleText)
    IF B = ObjReturn AND A = ObjActive AND Selected <> 0 THEN SWAP C1&, C2&
    Texter$ = MID$(TextBuf$(Objects(A).TextPtr), ((B - 1) * Objects(A).Flags) + 1, Objects(A).Flags)
    Future.PRINT Ex + 4 + ((B - 1) * 8 * LEN(Texter$)), Ey + 3, Texter$, C2&, C1&
   NEXT
   Future.BOX Ex - 1, Ey - 1, Ex + Wide + 5, Ey + 16 + 5, ObjSelect&
   
  CASE 12 'Scroll Bar on X Axis
  CASE 13 'Scroll Bar on Y Axis

  CASE 14 'EMS Sprite
   Future.EMSPut Ex, Ey, Objects(A).Flags

  CASE 15 'XMS Sprite
   Future.XMSput Ex, Ey, Objects(A).Flags

  CASE 16 'Base Sprite
   Future.DirectPut Ex, Ey, Objects(A).Flags, Objects(A).ID

  CASE 17 'Text Input
   Future.BOX Ex - 1, Ey - 1, Ex1, Ey + 21, ObjSelect&
   DrawBox3D Ex, Ey, Ex1 - 1, Ey + 20, Colors(4), Colors(Menu), BytePx * 5
   Lener = LEN(TextBuf$(Objects(A).TextPtr))
   LenX = (Ex1 - Ex - 10) \ 8
   Ptr = Objects(A).Flags - (LenX \ 2)
   IF Ptr < 1 THEN Ptr1 = 1 ELSE Ptr1 = Ptr
   Future.PRINT Ex + 4, Ey + 4, MID$(TextBuf$(Objects(A).TextPtr), Ptr1, LenX), Colors(Text), -1
   Future.LINE Ex + 12 + ((Objects(A).Flags - Ptr1) * 8), Ey + 4, Ex + 12 + ((Objects(A).Flags - Ptr1) * 8), Ey + 18, Colors(Text), -1

   CASE ELSE
  END SELECT
 END IF
 END IF

SetViewPort 0, 0, ResX, ResY
SetPage 0
IF Selected THEN ReFreshObject A
Windows(Win).Properties = Windows(Win).Properties OR Dirty
END IF
END SUB

SUB ObjRanges (Num)

 Win = Objects(Num).WinIndex
 Sx = Windows(Win).X + Windows(Win).DataOffX + Objects(Num).X - Windows(Win).ViewX - 2
 Sy = Windows(Win).Y + Windows(Win).DataOffY + Objects(Num).Y - Windows(Win).ViewY - 2
 Sx1 = Sx + Objects(Num).W + 4
 Sy1 = Sy + Objects(Num).H + 4
 LenX = LEN(TextBuf$(Objects(Num).TextPtr))

 SELECT CASE Objects(Num).Style

  CASE 4, 5'Text
   Sx1 = Sx + 22 + (LenX * 8)
   Sy1 = Sy + 18

  CASE 6, 20'Pull Menu
   Sx1 = Sx + ((Objects(Num).Flags + 1) * 8) + 8
   Sy1 = Sy + (((LenX \ Objects(Num).Flags) + SGN(LenX MOD Objects(Num).Flags)) * 16) + 8

  CASE 7 'Slider Bar (Vertical)
   Sx = Sx - 8
   Sy = Sy - 5
   Sx1 = Sx1 + 10
   Sy1 = Sy1 + 8

  CASE 8 ' Number Box
   Sx1 = Sx + 75
   Sy1 = Sy + 20

  CASE 17
   Sy1 = Sy + 24

  CASE 11 'Hoz Menu
   Sx1 = Sx + 7 + (LEN(TextBuf$(Objects(Num).TextPtr)) + 1) * 8
   Sy1 = Sy + 24

  CASE ELSE
 END SELECT

END SUB

'
'  Thanks to Steve Collision for helping letting me use his regioning code
'  coz i was too lazy to write my own =)
'
SUB ReDrawArea (X, Y, W, H, Windraw)

FOR N = 0 TO MaxWindows * 4
 Regions(N).Exist = False
NEXT N
LayerNum = 0

'Create Layers
DefLayer Windows(Win1st).X, Windows(Win1st).Y, Windows(Win1st).W, Windows(Win1st).H, Win1st
A = Windows(WinPtr).Prv
DO
 D = D + 1
 IF A <> Win1st THEN DefLayer Windows(A).X, Windows(A).Y, Windows(A).W, Windows(A).H, A
 A = Windows(A).Prv
LOOP WHILE A <> Windows(WinPtr).Prv

'/* Refresh layers */
Future.MouseOff
   FOR N = 0 TO MaxWindows * 4'LayerNum
      IF Regions(N).Exist THEN
	 X1 = Regions(N).X
	 Y1 = Regions(N).Y
	 X2 = Regions(N).X1
	 Y2 = Regions(N).Y1
	 IF Collide(X, Y, W, H, X1, Y1, X2 - X1, Y2 - Y1) THEN
	    IF X1 < X THEN X1 = X
	    IF Y1 < Y THEN Y1 = Y
	    IF X2 > X + W THEN X2 = X + W
	    IF Y2 > Y + H THEN Y2 = Y + H
	    OX = Regions(N).OffX
	    OY = Regions(N).OffY
	    L = Regions(N).WinName
	    IF Windraw = L OR Windraw < 0 THEN
	       Future.EMSPutx X1, Y1, Windows(L).Handle, X1 - OX, Y1 - OY, X2 - OX, Y2 - OY
	    END IF
	 END IF
      END IF
   NEXT N
Future.MouseOn
END SUB

SUB ReFreshObject (Num)
ObjRanges Num
ReDrawArea Sx, Sy, Sx1 - Sx, Sy1 - Sy, Objects(Num).WinIndex
END SUB

SUB RemoveObject (Num)

 IF Num = Windows(Objects(Num).WinIndex).Obj1st THEN Windows(Objects(Num).WinIndex).Obj1st = Objects(Windows(Objects(Num).WinIndex).Obj1st).Nxt
 Objects(Objects(Num).Nxt).Prv = Objects(Num).Prv
 Objects(Objects(Num).Prv).Nxt = Objects(Num).Nxt

 Objects(Num).Properties = 0

 IF Selected THEN ReFreshObject Num
END SUB

SUB ReSizeWinBuf (Win)

DeallExpMem Windows(Win).Handle
Windows(Win).Handle = AllExpMem(SizeOf(Windows(Win).W + 1, Windows(Win).H + 1))

DrawWindow Win
DrawWinScroll Win
DrawObjects Win

END SUB

SUB SetCols (Win)

 'Set Colors
 IF Win = ActiveWin THEN
  Title = 2
  TitleText = 3
  Menu = 4
  Button = 7
  WinCol = 11
  Text = 13
 ELSE
  Title = 9
  TitleText = 10
  Menu = 15
  Button = 8
  WinCol = 12
  Text = 14
 END IF

END SUB

SUB Shuffle (Orig, Dest)

IF Orig = Dest THEN EXIT SUB

S = WinPtr
FOR A = 1 TO Orig
 S = Windows(S).Nxt
NEXT

D = WinPtr
FOR A = 1 TO Dest
 D = Windows(D).Nxt
NEXT

IF (S = Windows(WinPtr).Prv AND WinPtr = D) THEN
 WinPtr = S
 EXIT SUB
END IF

IF (D = Windows(WinPtr).Prv AND WinPtr = S) THEN
 WinPtr = Windows(S).Nxt
 EXIT SUB
END IF

'Save all Vars
T1 = Windows(S).Nxt
T2 = Windows(S).Prv
T3 = S
T4 = Windows(D).Prv
T5 = Windows(D).Nxt
T6 = D

Windows(Windows(S).Prv).Nxt = T1
Windows(Windows(S).Nxt).Prv = T2

IF Dest < Orig THEN
 Windows(Windows(D).Prv).Nxt = T3
 Windows(D).Prv = T3
 Windows(S).Nxt = T6
 Windows(S).Prv = T4
ELSE
 Windows(Windows(D).Nxt).Prv = T3
 Windows(D).Nxt = T3
 Windows(S).Nxt = T5
 Windows(S).Prv = T6
END IF

FOR A = 1 TO Dest
 S = Windows(S).Prv
NEXT
WinPtr = S
END SUB

